package com.ejie.ab79.dao.listados;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.listados.Busquedas;
import com.ejie.ab79.model.listados.Listados;

/**
 * 
 *  
 *
 */

@Repository
@Transactional
public class BusquedasDaoImpl implements BusquedasDao {

	private JdbcTemplate jdbcTemplate;

	private RowMapper<Busquedas> rwMap = new RowMapper<Busquedas>() {
		public Busquedas mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			Busquedas busqueda = new Busquedas();
			busqueda.setIdBusqueda(resultSet.getInt("IDBUSQUEDA"));
			busqueda.setNombre(resultSet.getString("NOMBRE"));
			busqueda.setSqlListado(resultSet.getString("SQLLISTADO"));
			busqueda.setCampos(resultSet.getString("CAMPOS"));

			/* Lsitados */
			Listados listadosAux = new Listados();
			listadosAux.setIdListado(resultSet.getInt("IDLISTADO"));
			busqueda.setListados(listadosAux);

			return busqueda;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/**
	 * Finds rows in the Listados table using like.
	 *
	 * @param listados
	 *            Listados
	 * 
	 * @return List<Listados>
	 */
	@Transactional(readOnly = true)
	public List<Busquedas> findByListado(Busquedas busquedas) {
		StringBuilder query = new StringBuilder();
		List<Object> params = new ArrayList<Object>();

		query.append(
				"SELECT T1.ID_BUSQUEDA IDBUSQUEDA, T1.ID_LISTADO IDLISTADO, T1.NOMBRE NOMBRE, T1.SQL_LISTADO SQLLISTADO, T1.CAMPOS CAMPOS");
		query.append(" FROM BUSQUEDAS T1");
		query.append(" WHERE T1.ID_LISTADO = ?");
		params.add(busquedas.getListados().getIdListado());

		return (List<Busquedas>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
